- Main Page
- Classes
- Files
- Directories
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends

# FbxLayerContainer Class Reference

This reference page is linked to from the following overview topics: List of Python Fbx classes.

Search for all occurrences

## Detailed Description

Contains a collection of FbxLayer objects.

This class is used for managing layers construction, destruction and access. See FbxLayerElement for more details.

See also:
  FbxLayer

Definition at line 36 of file fbxlayercontainer.h.

`#include <fbxlayercontainer.h>`

Inheritance diagram for FbxLayerContainer:
[legend]

List of all members.

## Public Member Functions
virtual FbxNodeAttribute::EType | GetAttributeType () const
| Returns the type of node attribute.
bool | ConvertDirectToIndexToDirect (int pLayer)
| Converts the reference mode from eDirect to eIndexToDirect.
virtual FbxObject & | Copy (const FbxObject &pObject)
| Copy an object content into this object.
int | GTC (FbxUInt i, int j)
void * | GT (int i, FbxUInt l, int j)
int | AT (void *t, FbxUInt l, int j)
int | GTI (char const *n, FbxUInt l, int j)
int | GMC (FbxUInt i, void *n=NULL)
void * | GM (int i, FbxUInt l, void *n=NULL)
int | AM (void *m, FbxUInt l, void *n=NULL, bool b=false)
int | GMI (char const *n, FbxUInt l, void *d=NULL)
int | AddToLayerElementsList (FbxLayerElement *pLEl)
void | RemoveFromLayerElementsList (FbxLayerElement *pLEl)
## Protected Member Functions
| FbxLayerContainer (FbxManager &pManager, char const *pName)
virtual void | Destruct (bool pRecursive, bool pDependents)
void | CopyLayers (FbxLayerContainer const *pLayerContainer)
virtual void | SetDocument (FbxDocument *pDocument)
virtual bool | ConnecNotify (FbxConnectEvent const &pEvent)
## Protected Attributes
FbxArray< FbxLayer * > | mLayerArray
FbxArray< FbxLayerElement * > | mLayerElementsList
## Friends
class | FbxScene
class | FbxGeometryConverter
## Layer Management
int | CreateLayer ()
| Creates a new layer on top of existing layers.
void | ClearLayers ()
| Deletes all layers.
int | GetLayerCount () const
| Returns the number of layers.
int | GetLayerCount (FbxLayerElement::EType pType, bool pUVCount=false) const
| Returns the number of layers that contain the specified layer element type.
FbxLayer * | GetLayer (int pIndex)
| Returns the layer at the specified index.
FbxLayer const * | GetLayer (int pIndex) const
| Returns the layer at the specified index.
FbxLayer * | GetLayer (int pIndex, FbxLayerElement::EType pType, bool pIsUV=false)
| Returns the n'th layer as specified by pIndex that contains the specified layer element type.
FbxLayer const * | GetLayer (int pIndex, FbxLayerElement::EType pType, bool pIsUV=false) const
| Returns the n'th layer as specified by pIndex that contains the specified layer element type.
int | GetLayerIndex (int pIndex, FbxLayerElement::EType pType, bool pIsUV=false) const
| Returns the global index of the n'th layer as specified by pIndex that contains the specified layer element type.
int | GetLayerTypedIndex (int pGlobalIndex, FbxLayerElement::EType pType, bool pIsUV=false) const
| Converts the layer's global index to a type-specific index.

## Constructor & Destructor Documentation

FbxLayerContainer | ( | FbxManager & | pManager,
|  | char const * | pName
| ) |  | `[protected]`

## Member Function Documentation

virtual FbxNodeAttribute::EType GetAttributeType | ( |  | ) | const `[virtual]`

Search for all occurrences

Returns the type of node attribute.

Reimplemented from FbxNodeAttribute.

Reimplemented in FbxGeometry, FbxLine, FbxMesh, FbxNurbs, FbxNurbsCurve, FbxNurbsSurface, FbxPatch, FbxShape, FbxSubDiv, FbxBoundary, and FbxTrimNurbsSurface.

int CreateLayer | ( |  | ) |

Search for all occurrences

Creates a new layer on top of existing layers.

Returns:
  Index of created layer or -1 if an error occurs.

Examples:
  Instances/main.cxx.

void ClearLayers | ( |  | ) |

Search for all occurrences

Deletes all layers.

int GetLayerCount | ( |  | ) | const

Search for all occurrences

Returns the number of layers.

Returns:
  The number of layers.

int GetLayerCount | ( | FbxLayerElement::EType | pType,
|  | bool | pUVCount = `false`
| ) |  | const

Search for all occurrences

Returns the number of layers that contain the specified layer element type.

Parameters:

  pType | The specified Layer Element type.
  pUVCount | When `true`, requests the UV layer element corresponding to the specified texture type.

Returns:
  The number of layers containing the specified layer element type.

FbxLayer* GetLayer | ( | int | pIndex | ) |

Search for all occurrences

Returns the layer at the specified index.

Parameters:

  pIndex | Layer index.

Returns:
  Pointer to the layer, or `NULL` if pIndex is out of range.

Examples:
  Instances/main.cxx.

FbxLayer const* GetLayer | ( | int | pIndex | ) | const

Search for all occurrences

Returns the layer at the specified index.

Parameters:

  pIndex | Layer index.

Returns:
  Pointer to the layer, or `NULL` if pIndex is out of range.

FbxLayer* GetLayer | ( | int | pIndex,
|  | FbxLayerElement::EType | pType,
|  | bool | pIsUV = `false`
| ) |  |

Search for all occurrences

Returns the n'th layer as specified by pIndex that contains the specified layer element type.

If the pType is FbxLayerElement::eUV, this method will return the n'th layer as specified by pIndex that contains the diffuse UV. For example, GetLayer(int pIndex, FbxLayerElement::eUV) is same as GetLayer(int pIndex, FbxLayerElement::eTextureDiffuse, true).

Parameters:

  pIndex | Layer index.
  pType | The specified layer element type.
  pIsUV | When `true`, requests the UV layer element that corresponds with the specified texture type.

Returns:
  Pointer to the layer, or `NULL` if pIndex is out of range.

FbxLayer const* GetLayer | ( | int | pIndex,
|  | FbxLayerElement::EType | pType,
|  | bool | pIsUV = `false`
| ) |  | const

Search for all occurrences

Returns the n'th layer as specified by pIndex that contains the specified layer element type.

If the pType is FbxLayerElement::eUV, this method will return the n'th layer as specified by pIndex that contains the diffuse UV. For example, GetLayer(int pIndex, FbxLayerElement::eUV) is same as GetLayer(int pIndex, FbxLayerElement::eTextureDiffuse, true).

Parameters:

  pIndex | Layer index.
  pType | The specified layer element type.
  pIsUV | When `true`, requests the UV layer element that corresponds with the specified texture type.

Returns:
  Pointer to the layer, or `NULL` if pIndex is out of range.

int GetLayerIndex | ( | int | pIndex,
|  | FbxLayerElement::EType | pType,
|  | bool | pIsUV = `false`
| ) |  | const

Search for all occurrences

Returns the global index of the n'th layer as specified by pIndex that contains the specified layer element type.

Parameters:

  pIndex | Layer index of the specified type.
  pType | The specified layer element type.
  pIsUV | When `true`, requests the UV layer element that corresponds with the specified texture type.

Returns:
  Global index of the n'th layer as specified by pIndex that contains the specified layer element type, or -1 if the layer is not found.

Remarks:
  The returned index is the position of the layer in the global array of layers. You can use the returned index to call GetLayer(int pIndex).

int GetLayerTypedIndex | ( | int | pGlobalIndex,
|  | FbxLayerElement::EType | pType,
|  | bool | pIsUV = `false`
| ) |  | const

Search for all occurrences

Converts the layer's global index to a type-specific index.

Parameters:

  pGlobalIndex | The index of the layer in the global array of layers.
  pType | The type upon which the type-specific index will be returned.
  pIsUV | When `true`, requests the UV layer element that corresponds with the specified texture type.

Returns:
  Layer index of the specified layer element type, or -1 if the layer element type is not found on the layer.

bool ConvertDirectToIndexToDirect | ( | int | pLayer | ) |

Search for all occurrences

Converts the reference mode from eDirect to eIndexToDirect.

Parameters:

  pLayer | The Layer to convert.

Returns:
  `True` if conversion is successful, or `false` otherwise.

Remarks:
  For the time being, this method only applies to the LayerLementType eMaterial

virtual FbxObject& Copy | ( | const FbxObject & | pObject | ) | `[virtual]`

Search for all occurrences

Copy an object content into this object.

Parameters:

  pObject | The source object to copy data from.

Returns:
  Returns the destination object being modified by the source.

Remarks:
  This function replace the assignment operator (operator=). It will copy all property values and the name. Connections are NOT copied.

Reimplemented from FbxObject.

Reimplemented in FbxGeometry, FbxGeometryBase, FbxLine, FbxMesh, FbxNurbs, FbxNurbsCurve, FbxNurbsSurface, FbxPatch, FbxShape, FbxBoundary, and FbxTrimNurbsSurface.

int GTC | ( | FbxUInt | i,
|  | int | j
| ) |  |

Search for all occurrences

void* GT | ( | int | i,
|  | FbxUInt | l,
|  | int | j
| ) |  |

Search for all occurrences

int AT | ( | void * | t,
|  | FbxUInt | l,
|  | int | j
| ) |  |

Search for all occurrences

int GTI | ( | char const * | n,
|  | FbxUInt | l,
|  | int | j
| ) |  |

Search for all occurrences

int GMC | ( | FbxUInt | i,
|  | void * | n = `NULL`
| ) |  |

Search for all occurrences

void* GM | ( | int | i,
|  | FbxUInt | l,
|  | void * | n = `NULL`
| ) |  |

Search for all occurrences

int AM | ( | void * | m,
|  | FbxUInt | l,
|  | void * | n = `NULL`,
|  | bool | b = `false`
| ) |  |

Search for all occurrences

int GMI | ( | char const * | n,
|  | FbxUInt | l,
|  | void * | d = `NULL`
| ) |  |

Search for all occurrences

int AddToLayerElementsList | ( | FbxLayerElement * | pLEl | ) |

Search for all occurrences

void RemoveFromLayerElementsList | ( | FbxLayerElement * | pLEl | ) |

Search for all occurrences

virtual void Destruct | ( | bool | pRecursive,
|  | bool | pDependents
| ) |  | `[protected, virtual]`

Search for all occurrences

Reimplemented from FbxObject.

Reimplemented in FbxGeometry, FbxLine, FbxMesh, FbxNurbs, FbxNurbsCurve, FbxNurbsSurface, FbxPatch, and FbxSubDiv.

void CopyLayers | ( | FbxLayerContainer const * | pLayerContainer | ) | `[protected]`

Search for all occurrences

virtual void SetDocument | ( | FbxDocument * | pDocument | ) | `[protected, virtual]`

Search for all occurrences

Reimplemented from FbxObject.

Reimplemented in FbxGeometry.

virtual bool ConnecNotify | ( | FbxConnectEvent const & | pEvent | ) | `[protected, virtual]`

Search for all occurrences

Reimplemented from FbxObject.

## Friends And Related Function Documentation

friend class FbxScene `[friend]`

Search for all occurrences

Reimplemented from FbxNodeAttribute.

Reimplemented in FbxGeometry.

Definition at line 164 of file fbxlayercontainer.h.

friend class FbxGeometryConverter `[friend]`

Search for all occurrences

Reimplemented in FbxGeometryBase, FbxMesh, FbxNurbs, and FbxNurbsSurface.

Definition at line 165 of file fbxlayercontainer.h.

## Member Data Documentation

FbxArray<FbxLayer*> mLayerArray `[protected]`

Search for all occurrences

Definition at line 161 of file fbxlayercontainer.h.

FbxArray<FbxLayerElement*> mLayerElementsList `[protected]`

Search for all occurrences

Definition at line 162 of file fbxlayercontainer.h.

The documentation for this class was generated from the following file:

- fbxsdk/scene/geometry/fbxlayercontainer.h

FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer
FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer FbxLayerContainer